#!/system/bin/sh
# Please don't hardcode /magisk/modname/... ; instead, please use $MODDIR/...
# This will make your scripts compatible even if Magisk change its mount point in the future
MODDIR=${0%/*}

apply_setting() {
    if [ -e "$1" ]; then
        echo "$2" > "$1" && echo "Applied $2 to $1" || echo "Failed to apply $2 to $1"
    else
        echo "Skipped: $1 not available"
    fi
}

# MTK FPSGo and GPU Boost parameters
apply_setting "/sys/kernel/fpsgo/fbt/boost_ta" "1"
apply_setting "/sys/kernel/fpsgo/fbt/enable_switch_down_throttle" "0"
apply_setting "/sys/kernel/fpsgo/fstb/adopt_low_fps" "0"
apply_setting "/sys/kernel/fpsgo/fstb/fstb_self_ctrl_fps_enable" "0"
apply_setting "/sys/kernel/fpsgo/fstb/boost_ta" "1"
apply_setting "/sys/kernel/fpsgo/fstb/enable_switch_sync_flag" "0"
apply_setting "/sys/kernel/fpsgo/fbt/boost_VIP" "1"
apply_setting "/sys/kernel/fpsgo/fstb/gpu_slowdown_check" "0"
apply_setting "/sys/kernel/fpsgo/fbt/thrm_limit_cpu" "0"
apply_setting "/sys/kernel/fpsgo/fbt/thrm_limit_cpu" "0"
apply_setting "/sys/kernel/fpsgo/fbt/thrm_temp_th" "100"
apply_setting "/sys/kernel/fpsgo/fbt/llf_task_policy" "2"
apply_setting "/sys/kernel/ged/hal/gpu_boost_level" "101"

# MTK FPSGo advanced parameters
for param in boost_affinity boost_LR xgf_uboost xgf_extra_sub gcc_enable gcc_hwui_hint; do
    apply_setting "/sys/module/mtk_fpsgo/parameters/$param" "1"
done

# GED parameters
ged_params="ged_smart_boost 1
enable_gpu_boost 1
ged_boost_enable 1
boost_gpu_enable 1
gpu_dvfs_enable 1
gx_frc_mode 1
gx_force_cpu_boost 1
gx_boost_on 1
gx_game_mode 1
gx_3D_benchmark_on 1
cpu_boost_policy 1
boost_extra 1"

echo "$ged_params" | while read -r param value; do
    apply_setting "/sys/module/ged/parameters/$param" "$value"
done

apply_setting /sys/pnpmgr/fpsgo_boost/boost_enable default_mode
apply_setting /sys/kernel/ged/hal/custom_boost_gpu_freq 00

# This script will be executed in late_start service mode
# More info in the main Magisk thread
